diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -2723,7 +3403,7 @@ class YumBase(depsolve.Depsolve):
                 where = self.returnPackagesByDep(arg)
             else:
                 usedDepString = False
-                where = self.pkgSack.searchAll(arg, False)
+                where = self.pkgSack.searchProvides(arg)
             self.verbose_logger.log(logginglevels.DEBUG_1,
                P_('Searching %d package', 'Searching %d packages', len(where)), len(where))
             
@@ -2817,29 +3497,170 @@ class YumBase(depsolve.Depsolve):
             
         return matches
 
-    def doGroupLists(self, uservisible=0, patterns=None, ignore_case=True):
-        """returns two lists of groups, installed groups and available groups
-           optional 'uservisible' bool to tell it whether or not to return
-           only groups marked as uservisible"""
-        
-        
-        installed = []
-        available = []
+    def _groupInstalledData(self, group):
+        """ Return a dict of
+             pkg_name =>
+             (installed, available,
+             backlisted-installed, blacklisted-available). """
+        ret = {}
+        if not group or self.conf.group_command != 'objects':
+            return ret
+
+        pkg_names = {}
+        if group.groupid in self.igroups.groups:
+            pkg_names = self.igroups.groups[group.groupid].pkg_names
+
+        all_pkg_names = set(list(pkg_names))
+        if hasattr(group, 'packages'): # If a comps. group, add remote pkgs.
+            all_pkg_names.update(group.packages)
+
+        for pkg_name in all_pkg_names:
+            ipkgs = self.rpmdb.searchNames([pkg_name])
+            if pkg_name not in pkg_names and not ipkgs:
+                ret[pkg_name] = 'available'
+                continue
 
-        if self.comps.compscount == 0:
-            raise Errors.GroupsError, _('No group data available for configured repositories')
-        
-        if patterns is None:
-            grps = self.comps.groups
-        else:
-            grps = self.comps.return_groups(",".join(patterns),
-                                            case_sensitive=not ignore_case)
-        for grp in grps:
-            if grp.installed:
-                if uservisible:
-                    if grp.user_visible:
-                        installed.append(grp)
-                else:
+            if not ipkgs:
+                ret[pkg_name] = 'blacklisted-available'
+                continue
+
+            for ipkg in ipkgs:
+                # Multiarch, if any are installed for the group we count "both"
+                if ipkg.yumdb_info.get('group_member', '') != group.groupid:
+                    continue
+                ret[pkg_name] = 'installed'
+                break
+            else:
+                ret[pkg_name] = 'blacklisted-installed'
+
+        return ret
+
+    def _groupInstalledEnvData(self, evgroup):
+        """ Return a dict of
+             grp_name =>
+             (installed, available,
+             backlisted-installed, blacklisted-available). """
+        ret = {}
+        if not evgroup or self.conf.group_command != 'objects':
+            return ret
+
+        grp_names = {}
+        if evgroup.environmentid in self.igroups.groups:
+            grp_names = self.igroups.environments[evgroup.environmentid]
+            grp_names = grp_names.grp_names
+
+        all_grp_names = set(list(grp_names))
+        if hasattr(evgroup, 'allgroups'): # If a comps. evgroup, add remote grps
+            all_grp_names.update(evgroup.allgroups)
+
+        for grp_name in all_grp_names:
+            igrp = self.igroups.groups.get(grp_name)
+            if grp_name not in grp_names and not igrp:
+                ret[grp_name] = 'available'
+                continue
+
+            if not igrp:
+                ret[grp_name] = 'blacklisted-available'
+                continue
+
+            if igrp.environment == evgroup.environmentid:
+                ret[grp_name] = 'installed'
+            else:
+                ret[grp_name] = 'blacklisted-installed'
+
+        return ret
+
+    def _groupReturnGroups(self, patterns=None, ignore_case=True):
+        igrps = None
+        ievgrps = None
+        if patterns is None:
+            grps = self.comps.groups
+            if self.conf.group_command == 'objects':
+                igrps = self.igroups.groups.values()
+            evgrps = self.comps.environments
+            if self.conf.group_command == 'objects':
+                ievgrps = self.igroups.environments.values()
+            return igrps, grps, ievgrps, evgrps
+
+        gpats = []
+        epats = []
+        for pat in patterns:
+            if pat.startswith('@^'):
+                epats.append(pat[2:])
+            elif pat.startswith('@'):
+                gpats.append(pat[1:])
+            else:
+                epats.append(pat)
+                gpats.append(pat)
+
+        epats = ",".join(epats)
+        gpats = ",".join(gpats)
+
+        cs   = not ignore_case
+        grps = self.comps.return_groups(gpats, case_sensitive=cs)
+        #  Because we want name matches too, and we don't store group names
+        # we need to add the groupid's we've found:
+        if self.conf.group_command == 'objects':
+            gpats = gpats + "," + ",".join([grp.groupid for grp in grps])
+            igrps = self.igroups.return_groups(gpats, case_sensitive=cs)
+
+        evgrps = self.comps.return_environments(epats, case_sensitive=cs)
+        if self.conf.group_command == 'objects':
+            epats = epats+ "," + ",".join([grp.environmentid for grp in evgrps])
+            ievgrps = self.igroups.return_environments(epats, case_sensitive=cs)
+        return igrps, grps, ievgrps, evgrps
+
+    def doGroupLists(self, uservisible=0, patterns=None, ignore_case=True,
+                     return_evgrps=False):
+        """Return two lists of groups: installed groups and available
+        groups.
+
+        :param uservisible: If True, only groups marked as uservisible
+           will be returned. Otherwise, all groups will be returned
+        :param patterns: a list of stings.  If given, only groups
+           with names that match the patterns will be included in the
+           lists.  If not given, all groups will be included
+        :param ignore_case: whether to ignore case when determining
+           whether group names match the strings in *patterns*
+        :param return_evgrps: whether to return environment groups as well as
+           package groups
+        """
+        installed = []
+        available = []
+        einstalled = []
+        eavailable = []
+
+        if self.comps.compscount == 0:
+            raise Errors.GroupsError, _('No group data available for configured repositories')
+        
+        igrps, grps, ievgrps, evgrps = self._groupReturnGroups(patterns,
+                                                               ignore_case)
+
+        if igrps is not None:
+            digrps = {}
+            for igrp in igrps:
+                digrps[igrp.gid] = igrp
+            igrps = digrps
+
+        if ievgrps is not None:
+            digrps = {}
+            for ievgrp in ievgrps:
+                digrps[ievgrp.evgid] = ievgrp
+            ievgrps = digrps
+
+        for grp in grps:
+            if igrps is None:
+                grp_installed = grp.installed
+            else:
+                grp_installed = grp.groupid in igrps
+                if grp_installed:
+                    del igrps[grp.groupid]
+
+            if grp_installed:
+                if uservisible:
+                    if grp.user_visible:
+                        installed.append(grp)
+                else:
                     installed.append(grp)
             else:
                 if uservisible:
@@ -2847,34 +3668,97 @@ class YumBase(depsolve.Depsolve):
                         available.append(grp)
                 else:
                     available.append(grp)
+
+        for evgrp in evgrps:
+            if ievgrps is None:
+                evgrp_installed = evgrp.installed
+            else:
+                evgrp_installed = evgrp.environmentid in ievgrps
+                if evgrp_installed:
+                    del ievgrps[evgrp.environmentid]
+
+            if evgrp_installed:
+                einstalled.append(evgrp)
+            else:
+                eavailable.append(evgrp)
             
+        if igrps is None:
+            igrps = {}
+        if ievgrps is None:
+            ievgrps = {}
+
+        #  Note that we used to get here with igrps/ievgrps that didn't exist
+        # in comps. but we mock them in comps now because it was hard to deal
+        # with that everywhere ... so just to confirm.
+        assert not igrps
+        assert not ievgrps
+
+        for igrp in igrps.values():
+            #  These are installed groups that aren't in comps anymore. so we
+            # create fake comps groups for them.
+            grp = comps.Group()
+            grp.groupid = igrp.gid
+            grp.installed = True
+            grp.name = grp.groupid
+            for pkg_name in igrp.pkg_names:
+                grp.mandatory_packages[pkg_name] = 1
+            installed.append(grp)
+
+        for ievgrp in ievgrps.values():
+            #  These are installed evgroups that aren't in comps anymore. so we
+            # create fake comps evgroups for them.
+            evgrp = comps.Environment()
+            grp.environmentid = ievgrp.evgid
+            evgrp.installed = True
+            evgrp.name = evgrp.environmentid
+            evgrp._groups = list(ievgrp.groups)
+            einstalled.append(evgrp)
+
+        if return_evgrps:
+            return (sorted(installed), sorted(available),
+                    sorted(einstalled), sorted(eavailable))
         return sorted(installed), sorted(available)
     
-    
     def groupRemove(self, grpid):
-        """mark all the packages in this group to be removed"""
-        
+        """Mark all the packages in the given group to be removed.
+
+        :param grpid: the name of the group containing the packages to
+           mark for removal
+        :return: a list of transaction members added to the
+           transaction set by this function
+        """
         txmbrs_used = []
-        
+
         thesegroups = self.comps.return_groups(grpid)
         if not thesegroups:
             raise Errors.GroupsError, _("No Group named %s exists") % to_unicode(grpid)
 
         for thisgroup in thesegroups:
+            igroup_data = self._groupInstalledData(thisgroup)
+
             thisgroup.toremove = True
+
             pkgs = thisgroup.packages
-            for pkg in thisgroup.packages:
+            gid  = thisgroup.groupid
+
+            for pkg in pkgs:
+                if pkg in igroup_data and igroup_data[pkg] != 'installed':
+                    continue
+
                 txmbrs = self.remove(name=pkg, silence_warnings=True)
                 txmbrs_used.extend(txmbrs)
                 for txmbr in txmbrs:
-                    txmbr.groups.append(thisgroup.groupid)
+                    txmbr.groups.append(gid)
+            if igroup_data:
+                self.igroups.del_group(gid)
             
         return txmbrs_used
 
     def groupUnremove(self, grpid):
-        """unmark any packages in the group from being removed"""
-        
+        """Unmark any packages in the given group from being removed.
 
+        :param grpid: the name of the group to unmark the packages of
+        """
         thesegroups = self.comps.return_groups(grpid)
         if not thesegroups:
             raise Errors.GroupsError, _("No Group named %s exists") % to_unicode(grpid)
@@ -2898,18 +3782,53 @@ class YumBase(depsolve.Depsolve):
                             self.tsInfo.remove(txmbr.po.pkgtup)
         
         
-    def selectGroup(self, grpid, group_package_types=[], enable_group_conditionals=None):
-        """mark all the packages in the group to be installed
-           returns a list of transaction members it added to the transaction 
-           set
-           Optionally take:
-           group_package_types=List - overrides self.conf.group_package_types
-           enable_group_conditionals=Bool - overrides self.conf.enable_group_conditionals
+    def environmentRemove(self, evgrpid):
+        """Mark all the packages in the given group to be removed.
+
+        :param evgrpid: the name of the environment containing the groups to
+           mark for removal
+        :return: a list of transaction members added to the
+           transaction set by this function
+        """
+        txmbrs_used = []
+
+        thesegroups = self.comps.return_environments(evgrpid)
+        if not thesegroups:
+            raise Errors.GroupsError, _("No Environment named %s exists") % to_unicode(evgrpid)
+
+        for thisgroup in thesegroups:
+            igroup_data = self._groupInstalledEnvData(thisgroup)
+
+            grps  = thisgroup.allgroups
+            evgid = thisgroup.environmentid
+
+            for grp in grps:
+                if grp in igroup_data and igroup_data[grp] != 'installed':
+                    continue
+
+                txmbrs = self.groupRemove(grp)
+                txmbrs_used.extend(txmbrs)
+                for txmbr in txmbrs:
+                    txmbr.environments.append(evgid)
+            if igroup_data:
+                self.igroups.del_environment(evgid)
+
+        return txmbrs_used
+
+    def selectGroup(self, grpid, group_package_types=[],
+                    enable_group_conditionals=None, upgrade=False, ievgrp=None):
+        """Mark all the packages in the given group to be installed.
+
+        :param grpid: the name of the group containing the packages to
+           mark for installation
+        :param group_package_types: a list of the types of groups to
+           work with.  This overrides self.conf.group_package_types
+        :param enable_group_conditionals: overrides
+           self.conf.enable_group_conditionals
+        :return: a list of transaction members added to the
+           transaction set by this function
         """
 
-        if not self.comps.has_group(grpid):
-            raise Errors.GroupsError, _("No Group named %s exists") % to_unicode(grpid)
-        
         txmbrs_used = []
         thesegroups = self.comps.return_groups(grpid)
      
@@ -2920,12 +3839,18 @@ class YumBase(depsolve.Depsolve):
         if group_package_types:
             package_types = group_package_types
 
+        if self.conf.group_command == 'compat':
+            upgrade = False
+
         for thisgroup in thesegroups:
             if thisgroup.selected:
                 continue
             
             thisgroup.selected = True
             
+            # Can move to upgrade, if installed and calling install
+            lupgrade = upgrade
+
             pkgs = []
             if 'mandatory' in package_types:
                 pkgs.extend(thisgroup.mandatory_packages)
@@ -2934,12 +3859,56 @@ class YumBase(depsolve.Depsolve):
             if 'optional' in package_types:
                 pkgs.extend(thisgroup.optional_packages)
 
+            igroup_data = self._groupInstalledData(thisgroup)
+            igrp = None
+            if igroup_data:
+                if thisgroup.groupid in self.igroups.groups:
+                    igrp = self.igroups.groups[thisgroup.groupid]
+                    lupgrade = True
+                else:
+                    self.igroups.add_group(thisgroup.groupid,
+                                           thisgroup.packages, ievgrp)
+            for pkg in igroup_data:
+                if igroup_data[pkg] == 'installed':
+                    pkgs.append(pkg)
+
             old_txmbrs = len(txmbrs_used)
             for pkg in pkgs:
+                if self.conf.group_command == 'objects':
+                    assert pkg in igroup_data
+                    if (pkg not in igroup_data or
+                        igroup_data[pkg].startswith('blacklisted')):
+                        # (lupgrade and igroup_data[pkg] == 'available')):
+                        msg = _('Skipping package %s from group %s')
+                        self.verbose_logger.log(logginglevels.DEBUG_2,
+                                                msg, pkg, thisgroup.groupid)
+                        continue
+
                 self.verbose_logger.log(logginglevels.DEBUG_2,
                     _('Adding package %s from group %s'), pkg, thisgroup.groupid)
+
+                if igrp is not None:
+                    igrp.pkg_names.add(pkg)
+                    self.igroups.changed = True
+
+                txmbrs = []
                 try:
-                    txmbrs = self.install(name = pkg)
+                    if (lupgrade and
+                        (self.conf.group_command == 'simple' or
+                         (igroup_data and igroup_data[pkg] == 'installed'))):
+                        txmbrs = self.update(name = pkg,
+                                             pkg_warning_level='debug2')
+                    elif igroup_data and igroup_data[pkg] == 'installed':
+                        pass # Don't upgrade on install.
+                    else:
+                        txmbrs = self.install(name = pkg,
+                                              pkg_warning_level='debug2')
+                        for txmbr in txmbrs:
+                            txmbr.group_member = thisgroup.groupid
+                            if lupgrade: # For list transaction.
+                                txmbr._ugroup_member = thisgroup
+                            else:
+                                txmbr._igroup_member = thisgroup
                 except Errors.InstallError, e:
                     self.verbose_logger.debug(_('No package named %s available to be installed'),
                         pkg)
@@ -2953,7 +3922,9 @@ class YumBase(depsolve.Depsolve):
                 group_conditionals = enable_group_conditionals
 
             count_cond_test = 0
-            if group_conditionals:
+            # FIXME: What do we do about group conditionals when group==objects
+            #        or group upgrade for group_command=simple?
+            if not lupgrade and group_conditionals:
                 for condreq, cond in thisgroup.conditional_packages.iteritems():
                     if self.isPackageInstalled(cond):
                         try:
@@ -2990,17 +3961,23 @@ class YumBase(depsolve.Depsolve):
                         if cond not in self.tsInfo.conditionals:
                             self.tsInfo.conditionals[cond] = []
                         self.tsInfo.conditionals[cond].extend(pkgs)
-            if len(txmbrs_used) == old_txmbrs:
-                self.logger.critical(_('Warning: Group %s does not have any packages.'), thisgroup.groupid)
+
+            if not lupgrade and len(txmbrs_used) == old_txmbrs:
+                self.logger.critical(_('Warning: Group %s does not have any packages to install.'), thisgroup.groupid)
                 if count_cond_test:
-                    self.logger.critical(_('Group %s does have %u conditional packages, which may get installed.'), count_cond_test)
+                    self.logger.critical(_('Group %s does have %u conditional packages, which may get installed.'),
+                                         thisgroup.groupid, count_cond_test)
         return txmbrs_used
 
     def deselectGroup(self, grpid, force=False):
-        """ Without the force option set, this removes packages from being
-            installed that were added as part of installing one of the
-            group(s). If the force option is set, then all installing packages
-            in the group(s) are force removed from the transaction. """
+        """Unmark the packages in the given group from being
+        installed.
+
+        :param grpid: the name of the group containing the packages to
+           unmark from installation
+        :param force: if True, force remove all the packages in the
+           given group from the transaction
+        """
         
         if not self.comps.has_group(grpid):
             raise Errors.GroupsError, _("No Group named %s exists") % to_unicode(grpid)
@@ -3008,7 +3985,8 @@ class YumBase(depsolve.Depsolve):
         thesegroups = self.comps.return_groups(grpid)
         if not thesegroups:
             raise Errors.GroupsError, _("No Group named %s exists") % to_unicode(grpid)
-        
+
+        # FIXME: Do something with groups as objects, and env. groups.
         for thisgroup in thesegroups:
             thisgroup.selected = False
             
@@ -3034,13 +4012,114 @@ class YumBase(depsolve.Depsolve):
                         for pkg in self.tsInfo.conditionals.get(txmbr.name, []):
                             self.tsInfo.remove(pkg.pkgtup)
         
+    def selectEnvironment(self, evgrpid, group_package_types=[],
+                          enable_group_conditionals=None, upgrade=False):
+        """Mark all the groups in the given environment group to be installed.
+
+        :param evgrpid: the name of the env. group containing the groups to
+           mark for installation
+        :param group_package_types: a list of the types of groups to
+           work with.  This overrides self.conf.group_package_types
+        :param enable_group_conditionals: overrides
+           self.conf.enable_group_conditionals
+        :return: a list of transaction members added to the
+           transaction set by this function
+        """
+        evgrps = self.comps.return_environments(evgrpid)
+        if not evgrps:
+            raise Errors.GroupsError, _("No Environment named %s exists") % to_unicode(evgrpid)
+
+        ret = []
+        for evgrp in evgrps:
+
+            ievgrp = None
+            if self.conf.group_command == 'compat':
+                grps = ",".join(sorted(evgrp.groups))
+            elif self.conf.group_command == 'simple':
+                if not upgrade:
+                    grps = ",".join(sorted(evgrp.groups))
+                else: # Only upgrade the installed groups...
+                    grps = []
+                    for grpid in evgrp.groups:
+                        grp = self.comps.return_group(grpid)
+                        if grp is None:
+                            continue
+                        if not grp.installed:
+                            continue
+                        grps.append(grpid)
+                    grps = ",".join(sorted(grps))
+            elif self.conf.group_command == 'objects':
+                igroup_data = self._groupInstalledEnvData(evgrp)
+ 
+                grps = set()
+                for grpid in evgrp.groups:
+                    if (grpid not in igroup_data or
+                        igroup_data[grpid].startswith('blacklisted')):
+                        msg = _('Skipping group %s from environment %s')
+                        self.verbose_logger.log(logginglevels.DEBUG_2,
+                                                msg, grpid, evgrp.environmentid)
+                        continue
+                    grps.add(grpid)
+                if evgrp.environmentid in self.igroups.environments:
+                    ievgrp = self.igroups.environments[evgrp.environmentid]
+                    #  Add groups from the installed evgrp, for Eg. installed
+                    # only evgrps.
+                    for grp_name in ievgrp.grp_names:
+                        if grp_name not in self.igroups.groups:
+                            continue
+                        grp_evgrpid = self.igroups.groups[grp_name].environment
+                        if grp_evgrpid != evgrp.environmentid:
+                            continue
+                        grps.add(grp_name)
+                else:
+                    ievgrp = self.igroups.add_environment(evgrp.environmentid,
+                                                          evgrp.allgroups)
+                grps = ",".join(sorted(grps))
+
+            try:
+                txs = self.selectGroup(grps,
+                                       group_package_types,
+                                       enable_group_conditionals, upgrade,
+                                       ievgrp=ievgrp)
+            except Errors.GroupsError:
+                continue
+            ret.extend(txs)
+        return ret
+
+    def deselectEnvironment(self, evgrpid, force=False):
+        """Unmark the groups in the given environment group from being
+        installed.
+
+        :param evgrpid: the name of the environment group containing the
+           groups to unmark from installation
+        :param force: if True, force remove all the packages in the
+           given groups from the transaction
+        """
+        evgrps = self.comps.return_environments(evgrpid)
+        if not thesegroups:
+            raise Errors.GroupsError, _("No Environment named %s exists") % to_unicode(evgrpid)
+
+        for evgrp in evgrps:
+            grps = ",".join(sorted(evgrp.groups))
+            self.deselectGroup(grps, force)
+            # FIXME: env. needs to be marked not-to-be-installed, etc.
+
     def getPackageObject(self, pkgtup, allow_missing=False):
-        """retrieves a packageObject from a pkgtuple - if we need
-           to pick and choose which one is best we better call out
-           to some method from here to pick the best pkgobj if there are
-           more than one response - right now it's more rudimentary."""
-           
-        
+        """Return a package object that corresponds to the given
+        package tuple.
+
+        :param pkgtup: the package tuple specifying the package object
+           to return
+
+        :param allow_missing: If no package corresponding to the given
+           package tuple can be found, None is returned if
+           *allow_missing* is True, and a :class:`yum.Errors.DepError` is
+           raised if *allow_missing* is False.
+        :return: a package object corresponding to the given package tuple
+        :raises: a :class:`yum.Errors.DepError` if no package
+           corresponding to the given package tuple can be found, and
+           *allow_missing* is False
+        """
         # look it up in the self.localPackages first:
         for po in self.localPackages:
             if po.pkgtup == pkgtup:
@@ -3049,7 +4128,7 @@ class YumBase(depsolve.Depsolve):
         pkgs = self.pkgSack.searchPkgTuple(pkgtup)
 
         if len(pkgs) == 0:
-            self._add_not_found_a(pkgs, pkgtup)
+            self._add_not_found_a(pkgs, pkgtup=pkgtup)
             if allow_missing: #  This can happen due to excludes after .up has
                 return None   # happened.
             raise Errors.DepError, _('Package tuple %s could not be found in packagesack') % str(pkgtup)
@@ -3065,13 +4144,21 @@ class YumBase(depsolve.Depsolve):
         return result
 
     def getInstalledPackageObject(self, pkgtup):
-        """ Returns a YumInstalledPackage object for the pkgtup specified, or
-            raises an exception. You should use this instead of
-            searchPkgTuple() if you are assuming there is a value. """
-
+        """Return a :class:`yum.packages.YumInstalledPackage` object that
+        corresponds to the given package tuple.  This function should
+        be used instead of :func:`searchPkgTuple` if you are assuming
+        that the package object exists.
+
+        :param pkgtup: the package tuple specifying the package object
+           to return
+        :return: a :class:`yum.packages.YumInstalledPackage` object corresponding
+           to the given package tuple
+        :raises: a :class:`yum.Errors.RpmDBError` if the specified package
+           object cannot be found
+        """
         pkgs = self.rpmdb.searchPkgTuple(pkgtup)
         if len(pkgs) == 0:
-            self._add_not_found_i(pkgs, pkgtup)
+            self._add_not_found_i(pkgs, pkgtup=pkgtup)
             raise Errors.RpmDBError, _('Package tuple %s could not be found in rpmdb') % str(pkgtup)
 
         # Dito. FIXME from getPackageObject() for len() > 1 ... :)
@@ -3079,9 +4166,11 @@ class YumBase(depsolve.Depsolve):
         return po
         
     def gpgKeyCheck(self):
-        """checks for the presence of gpg keys in the rpmdb
-           returns 0 if no keys returns 1 if keys"""
+        """Checks for the presence of GPG keys in the rpmdb.
 
+        :return: 0 if there are no GPG keys in the rpmdb, and 1 if
+           there are keys
+        """
         gpgkeyschecked = self.conf.cachedir + '/.gpgkeyschecked.yum'
         if os.path.exists(gpgkeyschecked):
             return 1
@@ -3106,9 +4195,13 @@ class YumBase(depsolve.Depsolve):
             return 1
 
     def returnPackagesByDep(self, depstring):
-        """Pass in a generic [build]require string and this function will 
-           pass back the packages it finds providing that dep."""
+        """Return a list of package objects that provide the given
+        dependencies. 
 
+        :param depstring: a string specifying the dependency to return
+           the packages that fulfil
+        :return: a list of packages that fulfil the given dependency
+        """
         if not depstring:
             return []
 
@@ -3132,12 +4225,23 @@ class YumBase(depsolve.Depsolve):
                         raise Errors.YumBaseError, _('Invalid version flag from: %s') % str(depstring)
                     depflags = SYMBOLFLAGS[flagsymbol]
 
+        if depflags is None: # This does wildcards...
+            return self.pkgSack.searchProvides(depstring)
+
+        # This does flags+versions, but no wildcards...
         return self.pkgSack.getProvides(depname, depflags, depver).keys()
 
     def returnPackageByDep(self, depstring):
-        """Pass in a generic [build]require string and this function will 
-           pass back the best(or first) package it finds providing that dep."""
-        
+        """Return the best, or first, package object that provides the
+        given dependencies.
+
+        :param depstring: a string specifying the dependency to return
+           the package that fulfils
+        :return: the best, or first, package that fulfils the given
+           dependency
+        :raises: a :class:`yum.Errors.YumBaseError` if no packages that
+           fulfil the given dependency can be found
+        """
         # we get all sorts of randomness here
         errstring = depstring
         if type(depstring) not in types.StringTypes:
@@ -3149,16 +4253,22 @@ class YumBase(depsolve.Depsolve):
             raise Errors.YumBaseError, _('No Package found for %s') % errstring
         
         ps = ListPackageSack(pkglist)
-        result = self._bestPackageFromList(ps.returnNewestByNameArch())
+        result = self._bestPackageFromList(ps.returnNewestByNameArch(),
+                                           req=errstring)
         if result is None:
             raise Errors.YumBaseError, _('No Package found for %s') % errstring
         
         return result
 
     def returnInstalledPackagesByDep(self, depstring):
-        """Pass in a generic [build]require string and this function will 
-           pass back the installed packages it finds providing that dep."""
-        
+        """Return a list of installed package objects that provide the
+        given dependencies.
+
+        :param depstring: a string specifying the dependency to return
+           the packages that fulfil
+        :return: a list of installed packages that fulfil the given
+           dependency
+        """
         if not depstring:
             return []
 
